/**
 * -----------------------------------------------------
 * File        stamm_fastladder.sp
 * Authors     Bara
 * License     GPLv3
 * Web         https://bara.in
 * -----------------------------------------------------
 * 
 * Copyright (C) 2012-2014 Bara
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>
 */


// Includes
#include <sourcemod>

#undef REQUIRE_PLUGIN
#include <stamm>

#pragma semicolon 1
#pragma newdecls required



public Plugin myinfo = 
{
	name = "Stamm Feature FastLadder",
	author = "Bara",
	description = "Prohibit non VIP's the fast go up on ladders",
	version = "${-version-}", // Version is replaced by GitLab runner due the build phase
	url = "www.bara.in"
};



public void STAMM_OnFeatureLoaded(const char[] basename)
{
}



// Add feature for CSS and CSGO
public void OnAllPluginsLoaded()
{
	if (!STAMM_IsAvailable()) 
	{
		SetFailState("Can't Load Feature, Stamm is not installed!");
	}

	if (STAMM_GetGame() == GameTF2 || STAMM_GetGame() == GameDOD) 
	{
		SetFailState("Can't Load Feature, not Supported for your game!");
	}

	STAMM_LoadTranslation();
	STAMM_RegisterFeature("VIP FastLadder");
}




// Add descriptions
public void STAMM_OnClientRequestFeatureInfo(int client, int block, Handle &array)
{
	char fmt[256];
	
	Format(fmt, sizeof(fmt), "%T", "GetFastLadder", client);
	
	PushArrayString(array, fmt);
}



// Player climb on ladder?
public Action OnPlayerRunCmd(int client, int &buttons, int &impulse, float vel[3], float angles[3], int &weapon)
{
	if (STAMM_IsClientValid(client) && !STAMM_HaveClientFeature(client))
	{
		// Is it on a ladder?
		if (GetEntityMoveType(client) == MOVETYPE_LADDER)
		{
			// Change button if he is not a VIP
			if (buttons & IN_FORWARD || buttons & IN_BACK)
			{
				if (buttons & IN_MOVELEFT)
				{
					buttons &= ~IN_MOVELEFT;
				}

				if (buttons & IN_MOVERIGHT)
				{
					buttons &= ~IN_MOVERIGHT;
				}
			}
		}
	}
}
