/**
 * -----------------------------------------------------
 * File        stamm_fireweapon.sp
 * Authors     David <popoklopsi> Ordnung
 * License     GPLv3
 * Web         http://popoklopsi.de
 * -----------------------------------------------------
 * 
 * Copyright (C) 2012-2014 David <popoklopsi> Ordnung
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>
 */


// Includes 
#include <sourcemod>
#include <sdktools>

#undef REQUIRE_PLUGIN
#include <stamm>

#pragma semicolon 1
#pragma newdecls required



public Plugin myinfo =
{
	name = "Stamm Feature FireWeapon",
	author = "Popoklopsi",
	version = "${-version-}", // Version is replaced by GitLab runner due the build phase
	description = "VIP's can ignite players with there weapon",
	url = "https://gitlab.com/PushTheLimits/Sourcemod/Stamm/wikis"
};




public void STAMM_OnFeatureLoaded(const char[] basename)
{
}




// Add feature
public void OnAllPluginsLoaded()
{
	if (!STAMM_IsAvailable()) 
	{
		SetFailState("Can't Load Feature, Stamm is not installed!");
	}


	STAMM_LoadTranslation();
	STAMM_RegisterFeature("VIP FireWeapon");
}




// Add descriptions
public void STAMM_OnClientRequestFeatureInfo(int client, int block, Handle &array)
{
	char fmt[256];
	
	Format(fmt, sizeof(fmt), "%T", "GetFireWeapon", client);
	
	PushArrayString(array, fmt);
}




// Hook player hurt
public void OnPluginStart()
{
	HookEvent("player_hurt", PlayerHurt);
}




public void PlayerHurt(Handle event, char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	
	if (STAMM_IsClientValid(attacker) && client > 0 && client != attacker)
	{
		// Ignite on hit hehe
		if (STAMM_HaveClientFeature(attacker) && IsClientInGame(client) && IsPlayerAlive(client) && (GetClientTeam(client) != GetClientTeam(attacker)))
		{
			IgniteEntity(client, 2.0);
		}
	}
}